"
 COPYRIGHT (c) 1988 by Claus Gittinger / eXept Software AG
 COPYRIGHT (c) 2015-2016 Jan Vrany
 COPYRIGHT (c) 2021 LabWare
 COPYRIGHT (c) 2021 svestkap
 COPYRIGHT (c) 2021 Patrik Svestka
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

"{ NameSpace: Smalltalk }"

CodeViewTheme subclass:#Monokai
	instanceVariableNames:''
	classVariableNames:'BlackMonokai BlackOther BlackPro Blue BluePro Brown Green
		GreenPro Grey Magenta Orange OrangePro Pink PinkPro Purple
		PurplePro Red Sand White Yellow YellowPro'
	poolDictionaries:''
	category:'Views-Text-Theme'
!

!Monokai class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1988 by Claus Gittinger / eXept Software AG
 COPYRIGHT (c) 2015-2016 Jan Vrany
 COPYRIGHT (c) 2021 LabWare
 COPYRIGHT (c) 2021 svestkap
 COPYRIGHT (c) 2021 Patrik Svestka
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Based on Monokai and Monokai Pro colors for Sublime Text

    [Links to original Monokai/MonokaiPro]
        colorScheme := https://kolormark.com/brands/monokai
        authorPages := https://monokai.pro/vscode
        github := https://github.com/Monokai/monokai-pro-sublime-text
        sublimeTextPackage := https://packagecontrol.io/packages/Theme%20-%20Monokai%20Pro
 
    [author of Smalltalk/X port]
        Patrik Svestka
"
! !

!Monokai class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."
    
    "Monokai pro colors"
    BlackPro := Color rgbValue: 16r2d2a2e.
    BluePro := Color rgbValue: 16r78dce8.
    GreenPro := Color rgbValue: 16ra9dc76.
    OrangePro := Color rgbValue: 16rfc9867.
    PinkPro := Color rgbValue: 16rff6188.
    PurplePro := Color rgbValue: 16rab9df2.
    YellowPro := Color rgbValue: 16rffd866.
    "Monokai colors"
    BlackMonokai := Color rgbValue: 16r272822.
    Blue := Color rgbValue: 16r66d9ef.    
    Green := Color rgbValue: 16ra6e22e.
    Orange := Color rgbValue: 16rfd971f.
    Pink := Color rgbValue: 16rf92672.
    Purple := Color rgbValue: 16rae81ff.
    Yellow := Color rgbValue: 16re6db74.
    "Colors outside original Monokai"
    Brown := Color rgbValue: 16r74715e.
    Sand := Color rgbValue: 16reee8d5.
    BlackOther := Color rgbValue: 16r2e2e2e.
    Red := Color rgbValue: 16rff5252.
    Magenta := Color rgbValue: 16rd33682. 
    Grey := Color rgbValue: 16r595959.
    White := Color rgbValue: 16rd6d6d6.

    "Modified: / 11-12-2017 / 16:23:59 / jv"
    "Modified: / 04-11-2021 / 14:26:17 / svestkap"
    "Modified: / 15-11-2021 / 20:08:13 / Jan Vrany <jan.vrany@labware.com>"
    "Modified: / 18-11-2021 / 09:32:16 / Patrik Svestka <patrik.svestka@gmail.com>"
! !

!Monokai methodsFor:'styles'!

argumentIdentifierColor
    "the color used for argument identifiers;
     If syntaxColoring is turned on."        
     
    ^ self localIdentifierColor

    "Created: / 04-11-2021 / 14:43:02 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:16:20 / Patrik Svestka <patrik.svestka@gmail.com>"
!

argumentIdentifierEmphasis
    "the emphasis used for argument identifiers;
     If syntaxColoring is turned on."   
     
    ^ #italic

    "Created: / 04-11-2021 / 14:45:09 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:48:46 / Patrik Svestka <patrik.svestka@gmail.com>"
!

badIdentifierEmphasis
    "the emphasis used for illegal identifiers;
     If syntaxColoring is turned on."

    ^ self errorEmphasis

    "Created: / 20-12-2017 / 22:50:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

booleanConstantColor
    "the color used for boolean constants;
     If syntaxColoring is turned on."

    ^ self constantColor

    "Created: / 09-11-2021 / 10:18:26 / Patrik Svestka <patrik.svestka@gmail.com>"
!

booleanConstantEmphasis
    "the emphasis used for boolean constants;
     If syntaxColoring is turned on."

    ^ #italic

    "Created: / 09-11-2021 / 10:18:40 / Patrik Svestka <patrik.svestka@gmail.com>"
!

classVariableIdentifierColor
    "the color used for classVar/classInstVar identifiers
     If syntaxColoring is turned on."            

    ^ self instVarIdentifierColor

    "Created: / 04-11-2021 / 13:52:47 / svestkap"
    "Modified: / 08-11-2021 / 12:19:56 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 10:49:35 / Patrik Svestka <patrik.svestka@gmail.com>"
!

classVariableIdentifierEmphasis
    "the emphasis used for classVar/classInstVar identifiers
     If syntaxColoring is turned on."
     
    ^ #italic

    "Created: / 04-11-2021 / 13:53:06 / svestkap"
    "Modified: / 08-11-2021 / 16:11:31 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 25-11-2021 / 11:52:29 / Patrik Svestka <patrik.svestka@gmail.com>"
!

collectionEnumerationSelectorColor
    "the color used for some selected collection enumeration
     selectors (such as collect:, select: etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector color is used."        
     
    ^ OrangePro lighter

    "Created: / 04-11-2021 / 14:07:34 / svestkap"
    "Modified: / 04-11-2021 / 15:54:32 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:53:58 / Patrik Svestka <patrik.svestka@gmail.com>"
!

collectionEnumerationSelectorEmphasis
    "the emphasis used for some selected collection enumeration
     selectors (such as collect:, select: etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector color is used."
     
    ^ #italics

    "Created: / 04-11-2021 / 14:07:39 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:54:17 / Patrik Svestka <patrik.svestka@gmail.com>"
!

commentColor
    "the color used for comments;
     If syntaxColoring is turned on."   
     
    ^ Brown

    "Created: / 05-11-2021 / 13:44:03 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified: / 08-11-2021 / 15:01:36 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 10:55:03 / Patrik Svestka <patrik.svestka@gmail.com>"
!

commentEmphasis
    "the emphasis used for comments;
     If syntaxColoring is turned on."
     
    ^ #normal

    "Created: / 05-11-2021 / 13:46:47 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 10:55:12 / Patrik Svestka <patrik.svestka@gmail.com>"
!

constantColor
    "the color used for constants;
     If syntaxColoring is turned on."

    ^ GreenPro

    "Created: / 15-12-2017 / 22:56:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-01-2019 / 19:12:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 16:30:08 / svestkap"
    "Modified: / 09-11-2021 / 12:02:49 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 25-11-2021 / 11:52:43 / Patrik Svestka <patrik.svestka@gmail.com>"
!

constantEmphasis
    "the emphasis used for constants;
     If syntaxColoring is turned on."

    ^ #normal

    "Created: / 04-11-2021 / 16:30:46 / svestkap"
    "Modified: / 05-11-2021 / 14:12:59 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 10:55:18 / Patrik Svestka <patrik.svestka@gmail.com>"
!

controlFlowSelectorColor
    "the color used for some selected controlFlow selectors (such as if, while etc.);
     If syntaxColoring is turned on."
     
    ^ OrangePro

    "Created: / 04-11-2021 / 15:50:56 / svestkap"
    "Modified: / 15-11-2021 / 20:11:33 / Jan Vrany <jan.vrany@labware.com>"
    "Modified (comment): / 17-11-2021 / 09:57:32 / Patrik Svestka <patrik.svestka@gmail.com>"
!

controlFlowSelectorEmphasis
    "the emphasis used for some selected controlFlow selectors (such as if, while etc.);
     If syntaxColoring is turned on."
     
    ^ #normal

    "Created: / 04-11-2021 / 15:51:02 / svestkap"
    "Modified: / 05-11-2021 / 14:34:17 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 10:55:49 / Patrik Svestka <patrik.svestka@gmail.com>"
!

debugSelectorColor
    "the color used for some selected debug
     selectors (such as halt etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector color is used."

    ^ Red

    "Created: / 16-12-2017 / 21:40:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

debugSelectorEmphasis
    "the emphasis used for some selected debug
     selectors (such as halt etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector color is used."

    ^ #normal

    "Created: / 04-11-2021 / 16:20:11 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:55:59 / Patrik Svestka <patrik.svestka@gmail.com>"
!

defaultSyntaxBackground
    "Return a background color for the code editor. If nil is returned,
     a TextView's default background is used instead."

    ^ BlackMonokai

    "Created: / 11-12-2017 / 17:39:33 / jv"
    "Modified: / 16-12-2017 / 20:08:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-11-2021 / 10:58:51 / Patrik Svestka <patrik.svestka@gmail.com>"
!

defaultSyntaxColor
    "the color used for anything else;
     If syntaxColoring is turned on."

    ^ White

    "Created: / 11-12-2017 / 17:39:45 / jv"
    "Modified: / 16-12-2017 / 21:39:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 12:10:49 / svestkap"
    "Modified: / 09-11-2021 / 10:59:36 / Patrik Svestka <patrik.svestka@gmail.com>"
!

errorColor
    "the color used for illegal identifiers;
     If syntaxColoring is turned on."

    ^ Red

    "Created: / 05-11-2021 / 14:04:51 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified: / 17-11-2021 / 08:54:04 / Patrik Svestka <patrik.svestka@gmail.com>"
!

errorEmphasis
    "The emphasis used for raise an error;
     If syntaxColoring is turned on."
     
    ^ (Array with:#underwave with:(#underlineColor->Red))

    "Created: / 20-12-2017 / 22:51:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 25-11-2021 / 11:54:13 / Patrik Svestka <patrik.svestka@gmail.com>"
!

errorRaisingSelectorColor
    "the color used for some selected error raising
     selectors (such as raise etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector color is used."

    ^ self errorColor

    "Created: / 05-11-2021 / 13:58:52 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 08-11-2021 / 12:10:26 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified: / 15-11-2021 / 20:10:18 / Jan Vrany <jan.vrany@labware.com>"
!

errorRaisingSelectorEmphasis
    "the emphasis used for some selected error raising
     selectors (such as raise etc.);
     If syntaxColoring is turned on.
     If left nil, the normal selector emphasis is used."

    ^ #italic

    "Created: / 05-11-2021 / 13:59:16 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified: / 09-11-2021 / 12:08:46 / Patrik Svestka <patrik.svestka@gmail.com>"
!

globalClassIdentifierColor
    "the color used for global identifiers which are known to be classes;
     If syntaxColoring is turned on."

    ^ PurplePro

    "Created: / 08-11-2021 / 12:24:21 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified: / 09-11-2021 / 10:06:49 / Patrik Svestka <patrik.svestka@gmail.com>"
!

globalClassIdentifierEmphasis
    "the emphasis used for global variable identifiers which are known to be classes;
     If syntaxColoring is turned on."

    ^ #normal

    "Created: / 08-11-2021 / 12:24:33 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified: / 08-11-2021 / 16:12:34 / Patrik Svestka <patrik.svestka@gmail.com>"
!

globalIdentifierColor
    "the color used for global identifiers;
     If syntaxColoring is turned on."

    ^ self globalClassIdentifierColor

    "Created: / 09-11-2021 / 10:23:24 / Patrik Svestka <patrik.svestka@gmail.com>"
!

globalIdentifierEmphasis
    "the emphasis used for global variable identifiers;
     If syntaxColoring is turned on."

    ^ #italic

    "Created: / 09-11-2021 / 10:25:05 / Patrik Svestka <patrik.svestka@gmail.com>"
!

identifierColor
    "the color used for other identifiers;
     If syntaxColoring is turned on."

    ^ BluePro

    "
     UserPreferences current at:#identifierColor put:Color green darkened darkened.
     UserPreferences current at:#identifierColor put:Color black.
    "

    "Created: / 16-12-2017 / 21:41:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 16:10:31 / svestkap"
!

instVarIdentifierColor
    "the color used for instance variable identifiers;
     If syntaxColoring is turned on."
     
    ^ BluePro

    "Created: / 04-11-2021 / 13:29:54 / svestkap"
    "Modified: / 17-11-2021 / 09:16:03 / Patrik Svestka <patrik.svestka@gmail.com>"
!

instVarIdentifierEmphasis
    "the emphasis used for instance variable identifiers;
     If syntaxColoring is turned on."
     
    ^ #normal

    "Created: / 04-11-2021 / 13:40:18 / svestkap"
    "Modified: / 08-11-2021 / 16:10:52 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 11:13:29 / Patrik Svestka <patrik.svestka@gmail.com>"
!

localIdentifierColor
    "the color used for local variable identifiers;
     If syntaxColoring is turned on."
     
    ^ BluePro lighter

    "Created: / 04-11-2021 / 13:25:26 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:33:56 / Patrik Svestka <patrik.svestka@gmail.com>"
!

localIdentifierEmphasis
    "the emphasis used for local variable identifiers;
     If syntaxColoring is turned on."
     
    ^ #normal

    "Created: / 04-11-2021 / 14:45:46 / svestkap"
    "Modified (comment): / 09-11-2021 / 11:13:38 / Patrik Svestka <patrik.svestka@gmail.com>"
!

methodSelectorColor
    "the color used for a methods selector pattern;
     If syntaxColoring is turned on."           
     
    ^ White

    "Created: / 04-11-2021 / 13:58:06 / svestkap"
    "Modified (comment): / 09-11-2021 / 10:34:27 / Patrik Svestka <patrik.svestka@gmail.com>"
!

methodSelectorEmphasis
    "the emphasis used for a methods selector pattern;
     If syntaxColoring is turned on."

    ^ #bold

    "Created: / 16-12-2017 / 21:40:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 13:58:34 / svestkap"
    "Modified: / 09-11-2021 / 11:14:28 / Patrik Svestka <patrik.svestka@gmail.com>"
!

numberConstantColor
    "the color used for number constants;
     If syntaxColoring is turned on."

    ^ White

    "Created: / 16-12-2017 / 20:10:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 16:24:46 / svestkap"
!

numberConstantEmphasis
    "the emphasis used for number constants;
     If syntaxColoring is turned on."

    ^ #italic

    "Created: / 04-11-2021 / 16:26:28 / svestkap"
    "Modified: / 05-11-2021 / 14:11:16 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 11:15:21 / Patrik Svestka <patrik.svestka@gmail.com>"
!

poolVariableIdentifierColor
    "the color used for pool variable identifiers
     If syntaxColoring is turned on."

    ^ self globalIdentifierColor

    "Created: / 09-11-2021 / 10:43:19 / Patrik Svestka <patrik.svestka@gmail.com>"
!

poolVariableIdentifierEmphasis
    "the color used for pool variable identifiers
     If syntaxColoring is turned on."

    ^ Array with: #italic with: #bold  

    "Created: / 09-11-2021 / 10:43:26 / Patrik Svestka <patrik.svestka@gmail.com>"
!

selectorColor
    "the color used for message selectors;
     If syntaxColoring is turned on." 
     
    ^ White

    "Created: / 04-11-2021 / 12:39:26 / svestkap"
    "Modified: / 05-11-2021 / 14:31:10 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 11:16:20 / Patrik Svestka <patrik.svestka@gmail.com>"
!

selectorEmphasis
    "the emphasis used for message selectors;
     If syntaxColoring is turned on."

    ^ #normal

    "Created: / 05-11-2021 / 14:30:26 / Patrik Svestka <patrik.svestka@gmail.com>"
!

selfColor
    "the color used for the self pseudoVariable;
     If syntaxColoring is turned on."

    ^ OrangePro

    "Created: / 16-12-2017 / 20:11:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-01-2019 / 19:13:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 12:40:57 / svestkap"
    "Modified: / 17-11-2021 / 11:42:15 / Patrik Svestka <patrik.svestka@gmail.com>"
!

selfEmphasis
    "the emphasis used for the self pseudoVariable;
     If syntaxColoring is turned on."

    ^ #italic

    "Created: / 16-01-2019 / 19:14:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 15:55:41 / svestkap"
    "Modified: / 17-11-2021 / 11:42:23 / Patrik Svestka <patrik.svestka@gmail.com>"
!

stringColor
    "the color used for string constants;
     If syntaxColoring is turned on."
     
    ^ YellowPro

    "Created: / 04-11-2021 / 12:43:35 / svestkap"
    "Modified: / 08-11-2021 / 10:12:39 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 11:16:46 / Patrik Svestka <patrik.svestka@gmail.com>"
!

stringEmphasis
    "the emphasis used for string constants;
     If syntaxColoring is turned on."
     
    ^ #normal

    "Created: / 04-11-2021 / 16:33:30 / svestkap"
    "Modified (comment): / 09-11-2021 / 11:16:56 / Patrik Svestka <patrik.svestka@gmail.com>"
!

symbolColor
    "the color used for symbol constants;
     If syntaxColoring is turned on."
     
    ^ self stringColor

    "Created: / 04-11-2021 / 12:47:25 / svestkap"
    "Modified: / 04-11-2021 / 14:34:41 / svestkap"
    "Modified: / 08-11-2021 / 10:14:32 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 11:19:30 / Patrik Svestka <patrik.svestka@gmail.com>"
!

symbolEmphasis
    "the emphasis used for symbol constants;
     If syntaxColoring is turned on."
     
    ^ #italic

    "Created: / 04-11-2021 / 14:34:11 / svestkap"
    "Modified (comment): / 09-11-2021 / 11:19:40 / Patrik Svestka <patrik.svestka@gmail.com>"
!

thisContextColor
    "the color used for the thisContext pseudoVariable;
     If syntaxColoring is turned on."

    ^ self selfColor

    "Created: / 15-12-2017 / 22:58:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-11-2021 / 16:27:23 / svestkap"
    "Modified: / 08-11-2021 / 09:40:06 / Patrik Svestka <patrik.svestka@gmail.com>"
!

thisContextEmphasis
    "the emphasis used for the thisContext pseudoVariable;
     If syntaxColoring is turned on."

    ^ #normal

    "Created: / 04-11-2021 / 16:27:41 / svestkap"
    "Modified (comment): / 09-11-2021 / 11:19:11 / Patrik Svestka <patrik.svestka@gmail.com>"
!

variableColor
    "Unknown usage"        

    ^ self identifierColor

    "Created: / 09-11-2021 / 10:44:16 / Patrik Svestka <patrik.svestka@gmail.com>"
    "Modified (comment): / 09-11-2021 / 11:48:37 / Patrik Svestka <patrik.svestka@gmail.com>"
!

variableEmphasis

    ^ self identifierEmphasis

    "Created: / 09-11-2021 / 10:44:28 / Patrik Svestka <patrik.svestka@gmail.com>"
! !

!Monokai methodsFor:'styles - navigation'!

assignmentHighlightBackround

    ^ Red lighter

    "Created: / 15-09-2021 / 21:25:08 / Jan Vrany <jan.vrany@labware.com>"
    "Modified (format): / 04-11-2021 / 13:43:46 / svestkap"
!

selectorHighlightBackground

    ^ Sand darker darker

    "Created: / 15-09-2021 / 21:28:56 / Jan Vrany <jan.vrany@labware.com>"
    "Modified (comment): / 04-11-2021 / 14:41:27 / svestkap"
    "Modified: / 09-11-2021 / 10:13:15 / Patrik Svestka <patrik.svestka@gmail.com>"
!

variableHighlightBackground

    ^ Grey

    "Created: / 15-09-2021 / 21:29:10 / Jan Vrany <jan.vrany@labware.com>"
    "Modified: / 04-11-2021 / 13:46:08 / svestkap"
! !

!Monokai class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !


Monokai initialize!
